#include <stdio.h>

int main()
{
  fprintf(stderr, "static uint32_t default_2bit[4] = {\n");
  fprintf(stderr, "0x00000000,\n");
  fprintf(stderr, "0xFFFFFFFF,\n");
  fprintf(stderr, "0xFF000000,\n");
  fprintf(stderr, "0xFF%02X%02X%02X\n",128,128,128);
  fprintf(stderr, "};\n");
  
  fprintf(stderr, "static uint32_t default_4bit[16] = {\n");
  for (int i = 0; i < 16; i ++)
  {
    if (i & 0x8)
    {
      if (i == 0)
      {
	fprintf(stderr, "0x00000000,\n");
      }
      else
      {
	int r=0,g=0,b=0;
	if (i&1)
	  r = 0xFF;
	if (i&2)
	  g = 0xFF;
	if (i&4)
	  b = 0xFF;
	fprintf(stderr, "0xFF%02X%02X%02X,\n", b, g, r);
      }
    }
    else
    {
	int r=0,g=0,b=0;
	if (i&1)
	  r = 0x80;
	if (i&2)
	  g = 0x80;
	if (i&4)
	  b = 0x80;
	fprintf(stderr, "0xFF%02X%02X%02X,\n", b, g, r);
      
    }

  }
  fprintf(stderr, "};\n");

  fprintf(stderr, "static uint32_t default_8bit[256] = {\n");

  for (int i = 0; i < 256; i++)
  {
    if (i>0 && (i%4==0))
      fprintf(stderr,"\n");
    bool b1 = (i & 0x80) != 0;
    bool b5 = (i & 0x08) != 0;
    if (!b1 && !b5)
    {
      if (i==0)
      {
	fprintf(stderr, "0x00000000,");
      }
      else
      {
	int r=0,g=0,b=0;
	int t = 191;
	if (i&1)
	  r = 0xFF;
	if (i&2)
	  g = 0xFF;
	if (i&4)
	  b = 0xFF;
	
	fprintf(stderr, "0x%02X%02X%02X%02X,",t,b,g,r);

      }
    }
    if (!b1 && b5)
    {
      int r=0,g=0,b=0;
      int t = 0x80;
      if (i&1)
	r+=85;
      if (i&0x10)
	r+=170;
      
      if (i&2)
	g+=85;
      if (i&0x20)
	g+=170;
      
      if (i&4)
	b+=85;
      if (i&0x40)
	b+=170;
      fprintf(stderr, "0x%02X%02X%02X%02X,",t,b,g,r);
      
    }
    if (b1 && !b5)
    {
      int r=0x80-1, g=0x80-1, b=0x80-1;
      int t =0xFF; 
      if (i&1)
	r+=43;
      if (i&0x10)
	r+=85;
      
      if (i&2)
	g+=43;
      if (i&0x20)
	g+=85;
      
      if (i&4)
	b+=43;
      if (i&0x40)
	b+=85;
      
      
      fprintf(stderr, "0x%02X%02X%02X%02X,",t,b,g,r);

    }
    if (b1 && b5)
    {
      int r=0,g=0,b=0;
      int t = 0xFF;
      if (i&1)
	r+=43;
      if (i&0x10)
	r+=85;
      
      if (i&2)
	g+=43;
      if (i&0x20)
	g+=85;
      
      if (i&4)
	b+=43;
      if (i&0x40)
	b+=85;
      fprintf(stderr, "0x%02X%02X%02X%02X%c",t,b,g,r,i==255?'\n':',');

    }
  }
  fprintf(stderr, "};\n");

}

